#include "File.h"
std::string date_time::toString() {
	std::string buf;
	buf += std::to_string(this->year);
	buf += "-";
	if (this->month < 10) buf += "0";
	buf += std::to_string(this->month);
	buf += "-";
	if (this->day < 10) buf += "0";
	buf += std::to_string(this->day);
	buf += "/";

	if (this->hour < 10) buf += "0";
	buf += std::to_string(this->hour);;
	buf += ":";
	if (this->min < 10) buf += "0";
	if (this->min == 0) buf += "0";
	buf += std::to_string(this->min);

	return buf;
}

date_time& date_time::fromString(const std::string& s) {
	&(this->day);
	sscanf_s(s.c_str(), "%4d-%2d-%2d/%2d:%2d",
		&(this->year),
		&(this->month),
		&(this->day),
		&(this->hour),
		&(this->min));
	return *this;
}

void date_time::print() {
	std::cout << this->year <<
		"-" << std::setfill('0') << std::setw(2) << this->month <<
		"-" << std::setfill('0') << std::setw(2) << this->day <<
		"/" << std::setfill('0') << std::setw(2) << this->hour <<
		":" << std::setfill('0') << std::setw(2) << this->min;
}

std::istream& operator>>(std::istream& in, File& f) {
	std::string buf;
	std::cout << "Input the catalog: ";
	in >> f.catalog;
	std::cout << "Input the filename: ";
	in >> f.fname;
	std::cout << "Input the extension: ";
	in >> f.ext;
	std::cout << "Input the date and time (Example: 2022-01-09/15:01): ";
	in >> buf;
	f.dt.fromString(buf);
	std::cout << "Input the attribute (only_reading, hidden, systemic): ";
	in >> f.attr;
	std::cout << "Input the deletion sign (0 or 1): ";
	in >> f.del_sign;
	std::cout << "Input the number of allocated sectors: ";
	in >> f.al_sec;
	return in;
}

std::ostream& operator<<(std::ostream& out, File& file_info) {
	out << "Catalog: " << file_info.catalog << std::endl;
	out << "Name: " << file_info.fname << std::endl;
	out << "Extention: " << file_info.ext << std::endl;
	out << "Date and time: ";
	date_time d = file_info.dt;
	d.print();
	out << "\nAttribute: " << file_info.attr << std::endl;
	out << "Deletion sign: " << file_info.del_sign << std::endl;
	out << "Number of allocated sectors: " << file_info.al_sec << std::endl;
	out << "\n";
	return out;
}

File::File(const File& file_info)
	: dt(file_info.dt)
	, del_sign(file_info.del_sign)
	, al_sec(file_info.al_sec) {
	strcpy_s(catalog, file_info.catalog);
	strcpy_s(fname, file_info.fname);
	strcpy_s(ext, file_info.ext);
	strcpy_s(attr, file_info.attr);
}

File& File::operator=(const File& file_info) {
	if (this != &file_info) {
		strcpy_s(catalog, file_info.catalog);
		strcpy_s(fname, file_info.fname);
		strcpy_s(ext, file_info.ext);
		dt = file_info.dt;
		strcpy_s(attr, file_info.attr);
		del_sign = file_info.del_sign;
		al_sec = file_info.al_sec;
	}
	return *this;
}