#include "Functions.h"

void createData_v1(const std::string& fname) {
	std::ofstream f(fname);
	if (!f) { // file opened ?
		std::cerr << "Error: cant open output file " << fname << std::endl;
		exit(EXIT_FAILURE);
	}
	std::random_device rnd_device;
	std::mt19937 mersenne_engine(rnd_device());
	std::uniform_int_distribution<int> dist(-50, 50);
	auto gen = std::bind(dist, mersenne_engine);
	for (int i = 0; i < 100; ++i) {
		int value = gen();
		f << value << " ";
	}
	f.close();
};

void modify_v4(const std::string& fname) {
	std::ifstream f(fname);
	std::string resname = "transformed_data.txt";
	std::ofstream res(resname);
	int n = 0;
	double ar_mean = 0;
	double sum = 0;
	std::for_each(std::istream_iterator<int>(f), std::istream_iterator<int>(), [&](auto& a) { sum += a; n++; });
	ar_mean = sum / n;
	std::cout << sum << "  " << n << std::endl;
	f.close();
	f.open(fname);
	std::transform(std::istream_iterator<int>(f), std::istream_iterator<int>(), std::ostream_iterator<double>(res, " "), [&](int b) -> double {
		if ((int)abs(b) % 2 == 1) return (double)b / ar_mean;
		else return (double)b; });
	f.close();
	res.close();
}